﻿using System;
using JetBrains.Annotations;
using OpcLabs.BaseLib.DataTypeModel;

namespace OpcLabs.BaseLibFactory.DataTypeModel
{
    static public class PrimitiveDataInstances
    {
        [NotNull]
        static public PrimitiveData Instance1 => new PrimitiveData(0);

        [NotNull]
        static public PrimitiveData Instance2 => new PrimitiveData(PrimitiveDataTypeInstances.Instance4, 1);

        [NotNull]
        static public PrimitiveData SByte => new PrimitiveData((SByte)1);

        [NotNull]
        static public PrimitiveData Int16 => new PrimitiveData((Int16)1);

        [NotNull]
        static public PrimitiveData Int32 => new PrimitiveData(1);

        [NotNull]
        static public PrimitiveData Int64 => new PrimitiveData((Int64)1);

        [NotNull]
        static public PrimitiveData Byte => new PrimitiveData((Byte)1);

        [NotNull]
        static public PrimitiveData UInt16 => new PrimitiveData((UInt16)1);

        [NotNull]
        static public PrimitiveData UInt32 => new PrimitiveData((UInt32)1);

        [NotNull]
        static public PrimitiveData UInt64 => new PrimitiveData((UInt64)1);

        [NotNull]
        static public PrimitiveData Single => new PrimitiveData((Single)1);

        [NotNull]
        static public PrimitiveData Double => new PrimitiveData((Double)1);

        [NotNull]
        static public PrimitiveData Decimal => new PrimitiveData((Decimal)1);

        [NotNull]
        static public PrimitiveData Boolean => new PrimitiveData(true);

        [NotNull]
        static public PrimitiveData Char => new PrimitiveData((Char)1);

        [NotNull]
        static public PrimitiveData String => new PrimitiveData("one");

        [NotNull]
        static public PrimitiveData DateTime1 => new PrimitiveData(DateTimeInstances.Instance1);

        [NotNull]
        static public PrimitiveData DateTime2 => new PrimitiveData(DateTimeInstances.Instance2);

        [NotNull]
        static public PrimitiveData DateTimeUtc => new PrimitiveData(DateTimeInstances.Kind_Utc);

        [NotNull]
        static public PrimitiveData DateTimeLocal => new PrimitiveData(DateTimeInstances.Kind_Local);

        [NotNull]
        static public PrimitiveData DateTimeMin => new PrimitiveData(DateTimeBoundaryInstances.MinValue);

        [NotNull]
        static public PrimitiveData DateTimeMax => new PrimitiveData(DateTimeBoundaryInstances.MaxValue);

        [NotNull]
        static public PrimitiveData Guid => new PrimitiveData(new Guid("68A79DC9-DC43-4715-AA67-8BEA9538FC98"));

        [NotNull]
        static public PrimitiveData GuidEmpty => new PrimitiveData(System.Guid.Empty);

        [NotNull]
        static public PrimitiveData ArrayOfByte0 => new PrimitiveData(new byte[0]);

        [NotNull]
        static public PrimitiveData ArrayOfByte1 => new PrimitiveData(new byte []{1, 2, 255, 254});
    }
}
