﻿using System.Globalization;
using JetBrains.Annotations;
using OpcLabs.BaseLib.LiveBinding;
using OpcLabs.BaseLibFactory.ComponentModel;
using OpcLabs.BaseLibFactory.Components;

namespace OpcLabs.BaseLibFactory.LiveBinding
{
    static public class BindingBaseInstances
    {
        [NotNull]
        static public BindingBase Instance0 => new BindingBase();

        [NotNull]
        static public BindingBase Instance1 => new BindingBase { ValueTarget = ValueTargetInstances.Instance1 };

        [NotNull]
        static public BindingBase Instance2 => new BindingBase
        {
            ValueTarget = ValueTargetInstances.Instance2,
            StringFormat = "testStringFormat"
        };

        [NotNull]
        static public BindingBase Instance3 => new BindingBase
        {
            ValueTarget = ValueTargetInstances.Instance3,
            StringFormat = "testStringFormat",
            Converter = LinearConverterInstances.Instance1
        };

        [NotNull]
        static public BindingBase Instance4 => new BindingBase
        {
            ValueTarget = ValueTargetInstances.Instance4,
            StringFormat = "testStringFormat",
            Converter = LinearConverterInstances.Instance2,
            ConverterParameter = new object()
        };

        [NotNull]
        static public BindingBase Instance5 => new BindingBase
        {
            ValueTarget = ValueTargetInstances.Instance4,
            StringFormat = "testStringFormat",
            Converter = LinearConverterInstances.Instance2,
            ConverterParameter = "testConverterParameterString"
        };

        [NotNull]
        static public BindingBase Instance6 => new BindingBase
        {
            ValueTarget = ValueTargetInstances.Instance4,
            StringFormat = "testStringFormat",
            Converter = LinearConverterInstances.Instance2,
            ConverterParameter = "testConverterParameterString",
            Culture = new CultureInfo("ar-SA")
        };

        [NotNull]
        static public BindingBase Instance7 => new BindingBase
        {
            ValueTarget = ValueTargetInstances.Instance4,
            BindingGroup = AbstractBindingGroupInstances.Instance0,
        };
    }
}
