﻿using System;
using JetBrains.Annotations;
using OpcLabs.EasyOpc.UA.AddressSpace;

namespace OpcLabs.EasyOpcFactory.UA.AddressSpace
{
    static public class UANodeIdInstances
    {
        private const int NamespaceIndex1 = 777;
        private const string NamespaceUri1 = "testNamespaceUri";

        [NotNull]
        static public UANodeId NumericIdentifier_MaxValue => new UANodeId(NamespaceIndex1, NamespaceUri1, UInt32.MaxValue);

        [NotNull]
        static public UANodeId NumericIdentifier_Positive => new UANodeId(NamespaceIndex1, NamespaceUri1, 767676);

        [NotNull]
        static public UANodeId NumericIdentifier_Zero => new UANodeId(NamespaceIndex1, NamespaceUri1, 0);

        [NotNull]
        static public UANodeId StringIdentifier_Empty => new UANodeId(NamespaceIndex1, NamespaceUri1, "");

        [NotNull]
        static public UANodeId StringIdentifier_Normal => new UANodeId(NamespaceIndex1, NamespaceUri1, "testStringIdentifier");

        [NotNull]
        static public UANodeId StringIdentifier_OneChar => new UANodeId(NamespaceIndex1, NamespaceUri1, "A");

        [NotNull]
        static public UANodeId GuidIdentifier_Null => new UANodeId(NamespaceIndex1, NamespaceUri1, new Guid());

        [NotNull]
        static public UANodeId GuidIdentifier_Normal => new UANodeId(NamespaceIndex1, NamespaceUri1, new Guid("{1D1D77C5-05EB-4479-A210-DF9C32207456}"));

        [NotNull]
        static public UANodeId OpaqueIdentifier_Empty => new UANodeId(NamespaceIndex1, NamespaceUri1, new byte[0]);

        [NotNull]
        static public UANodeId OpaqueIdentifier_Length5 => new UANodeId(NamespaceIndex1, NamespaceUri1, new byte[] { 11, 22, 33, 44, 55 });

        [NotNull]
        static public UANodeId OpaqueIdentifier_MaxValues => new UANodeId(NamespaceIndex1, NamespaceUri1, new byte[] { 0xFF, 0xFF, 0xFF });

        [NotNull]
        static public UANodeId OpaqueIdentifier_MinValues => new UANodeId(NamespaceIndex1, NamespaceUri1, new byte[] { 0, 0, 0 });

        [NotNull]
        static public UANodeId OpaqueIdentifier_OneByte => new UANodeId(NamespaceIndex1, NamespaceUri1, new byte[] { 111 });

        [NotNull]
        static public UANodeId NoNamespaceIndex => new UANodeId(NamespaceUri1, "testStringIdentifier");

        [NotNull]
        static public UANodeId NoNamespaceUri => new UANodeId(NamespaceIndex1, "", "testStringIdentifier");
    }
}
