﻿using JetBrains.Annotations;
using OpcLabs.BaseLibFactory.IdentityModel.User;
using OpcLabs.BaseLibFactory.Security;
using OpcLabs.EasyOpc.UA;
using OpcLabs.EasyOpcFactory.UA.Engine;

namespace OpcLabs.EasyOpcFactory.UA
{
    static public class UAEndpointDescriptorInstances
    {
        [NotNull]
        static public UAEndpointDescriptor Instance1 => new UAEndpointDescriptor("testUrlString");

        [NotNull]
        static public UAEndpointDescriptor Instance2
        {
            get
            {
                UAEndpointDescriptor endpointDescriptor = Instance1;
                endpointDescriptor.NetworkSecurity = NetworkSecurityInstances.Instance1;
                return endpointDescriptor;
            }
        }

        [NotNull]
        static public UAEndpointDescriptor Instance3
        {
            get
            {
                UAEndpointDescriptor endpointDescriptor = Instance1;
                endpointDescriptor.UserIdentity = UserIdentityInstances.Instance1;
                return endpointDescriptor;
            }
        }

        [NotNull]
        static public UAEndpointDescriptor Instance4
        {
            get
            {
                UAEndpointDescriptor endpointDescriptor = Instance1;
                endpointDescriptor.CertificateAcceptancePolicy = UACertificateAcceptancePolicyInstances.Instance1;
                return endpointDescriptor;
            }
        }

        [NotNull]
        static public UAEndpointDescriptor Instance5
        {
            get
            {
                UAEndpointDescriptor endpointDescriptor = Instance1;
                endpointDescriptor.EndpointSelectionPolicy = UAEndpointSelectionPolicyInstances.Instance1;
                return endpointDescriptor;
            }
        }

        [NotNull]
        static public UAEndpointDescriptor Instance6
        {
            get
            {
                UAEndpointDescriptor endpointDescriptor = Instance2;
                endpointDescriptor.UserIdentity = UserIdentityInstances.Instance1;
                endpointDescriptor.CertificateAcceptancePolicy = UACertificateAcceptancePolicyInstances.Instance1;
                endpointDescriptor.EndpointSelectionPolicy = UAEndpointSelectionPolicyInstances.Instance1;
                return endpointDescriptor;
            }
        }

        [NotNull]
        static public UAEndpointDescriptor Instance7
        {
            get
            {
                UAEndpointDescriptor endpointDescriptor = Instance2;
                endpointDescriptor.UserIdentity = UserIdentityInstances.Instance1;
                endpointDescriptor.CertificateAcceptancePolicy = UACertificateAcceptancePolicyInstances.Instance1;
                endpointDescriptor.EndpointSelectionPolicy = UAEndpointSelectionPolicyInstances.Instance1;
                endpointDescriptor.ServerCertificateByteArray = new byte[] {0};
                return endpointDescriptor;
            }
        }

        [NotNull]
        static public UAEndpointDescriptor Instance8
        {
            get
            {
                UAEndpointDescriptor endpointDescriptor = Instance2;
                endpointDescriptor.UserIdentity = UserIdentityInstances.Instance1;
                endpointDescriptor.CertificateAcceptancePolicy = UACertificateAcceptancePolicyInstances.Instance1;
                endpointDescriptor.EndpointSelectionPolicy = UAEndpointSelectionPolicyInstances.Instance1;
                endpointDescriptor.ServerCertificateByteArray = new byte[] {12, 34, 56, 78, 90, 100, 110, 200, 250};
                return endpointDescriptor;
            }
        }

        [NotNull]
        static public UAEndpointDescriptor InvalidFormat = new UAEndpointDescriptor { UrlString = "!@#$%^&*()" };
    }
}
