﻿using System;
using JetBrains.Annotations;

namespace OpcLabs.UnitTestLib
{
    public class DelegatedTestMethod : TestMethod
    {
        #region Public Constructors

        public DelegatedTestMethod([NotNull] string name, [NotNull] Action testAction)
            : base(name)
        {
            TestAction = testAction;
        }

        #endregion



        #region Public Properties

        [NotNull]
        public Action TestAction { get; }

        #endregion



        #region Public Methods

        public override void Test()
        {
            TestAction();
        }

        #endregion
    }
}
