﻿using System;
using System.Windows.Forms;
using OpcLabs.BaseLib.Forms.Testing;
using OpcLabs.EasyOpcFormsTestApp.DataAccess;
using OpcLabs.EasyOpcFormsTestApp.Design;
using OpcLabs.EasyOpcFormsTestApp.Properties;
using OpcLabs.EasyOpcFormsTestApp.UA;

namespace OpcLabs.EasyOpcFormsTestApp
{
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
#if (NETSTANDARD)
            Application.SetHighDpiMode(HighDpiMode.SystemAware);
#endif
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);

            var switchboardForm = new SwitchboardForm
            {
                Text = Resources.Program_Main_SwitchboardForm_Text,
                CommandDictionary =
                {
                    ["DataAccess.BrowseControls"] = DACommands.BrowseControls,
                    ["DataAccess.LiveBinding"] = DACommands.LiveBinding,
                    ["DataAccess.ObjectTestbed"] = DACommands.ObjectTestbed,
                    ["DataAccess.PointEditorControlWithDAConnectivity"] = DACommands.PointEditorControlWithDAConnectivity,
                    ["DataAccess.PointEditorControlWithUAConnectivity"] = DACommands.PointEditorControlWithUAConnectivity,
                    ["Multi.CompositeLiveBinding"] = Multi.Commands.CompositeLiveBinding,
                    ["Multi.Dialogs"] = Multi.Commands.Dialogs,
                    ["UA.BrowseControls"] = UACommands.BrowseControls,
                    ["UA.ChallengeTest"] = UACommands.ChallengeTest,
                    ["UA.ObjectTestbed"] = UACommands.ObjectTestbed,
                    ["Design"] = Commands.Design
                }
            };

            Application.Run(switchboardForm);
        }
    }
}
