﻿
using System.Collections.Generic;
using JetBrains.Annotations;
using OpcLabs.BaseLib.IdentityModel.User;
using OpcLabs.EasyOpc.UA;

namespace OpcLabs.EasyOpcLiveTest.UA.Environment
{
    // ReSharper disable once InconsistentNaming
    public class OpcFoundation_GlobalDiscoveryServer : UAServer
    {
        static public class BrowsePathStrings
        {
        }

        public class EndpointDescriptorsInfo
        {
            public EndpointDescriptorsInfo([NotNull] OpcFoundation_GlobalDiscoveryServer parent)
            {
                _parent = parent;
            }

            [NotNull]
            public UAEndpointDescriptor Https => new UAEndpointDescriptor(_parent._endpointUrlStrings.Https);

            [NotNull]
            public UAEndpointDescriptor OpcTcp => new UAEndpointDescriptor(_parent._endpointUrlStrings.OpcTcp);

            [NotNull]
            private readonly OpcFoundation_GlobalDiscoveryServer _parent;
        }

        static public class NamespaceUriStrings
        {
        }

        static public class NodeIdExpandedTexts
        {
        }

        static public class UserIdentities
        {
            [NotNull]
            static public UserIdentity Admin = UserIdentity.CreateUserNameIdentity("appadmin", "demo");

            [NotNull]
            static public UserIdentity User = UserIdentity.CreateUserNameIdentity("appuser", "demo");
        }



        private class EndpointUrlStringsInfo
        {
            public EndpointUrlStringsInfo([NotNull] OpcFoundation_GlobalDiscoveryServer parent)
            {
                _parent = parent;
            }

            [NotNull]
            public string Https => "https://" + _parent.HostName + ":58812/GlobalDiscoveryServer/";
            [NotNull]
            public string OpcTcp => "opc.tcp://" + _parent.HostName + ":58810/GlobalDiscoveryServer";

            [NotNull]
            private readonly OpcFoundation_GlobalDiscoveryServer _parent;
        }



        public OpcFoundation_GlobalDiscoveryServer([NotNull] string hostName) 
            : base(hostName)
        {
            EndpointDescriptors = new EndpointDescriptorsInfo(this);
            _endpointUrlStrings = new EndpointUrlStringsInfo(this);
        }

        [NotNull]
        public readonly EndpointDescriptorsInfo EndpointDescriptors;

        [NotNull]
        private readonly EndpointUrlStringsInfo _endpointUrlStrings;

        public override IEnumerable<UAEndpointDescriptor> AllEndpointDescriptors
        {
            get
            {
                yield return EndpointDescriptors.OpcTcp;
                yield return EndpointDescriptors.Https;
            }
        }
    }
}
