﻿using System.ComponentModel.Design.Serialization;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc;
using OpcLabs.EasyOpc.Internal;
using OpcLabs.EasyOpcFactory;

namespace OpcLabs.EasyOpcTest
{
    public partial class ServerDescriptorConverterTest
    {
        [TestMethod]
        public void ConvertToTest_InstanceDescriptor_Instance1()
        {
            var target = new ServerDescriptorConverter();
            ServerDescriptor serverDescriptor = ServerDescriptorInstances.Instance1;
            object converted = target.ConvertTo(null, null, serverDescriptor, typeof (InstanceDescriptor));
            Assert.IsNotNull(converted);
            Assert.IsInstanceOfType(converted, typeof(InstanceDescriptor));
            var instanceDescriptor = (InstanceDescriptor) converted;
            object newInstance = instanceDescriptor.Invoke();
            Assert.IsNotNull(newInstance);
            Assert.IsInstanceOfType(newInstance, typeof(ServerDescriptor));
            var newServerDescriptor = (ServerDescriptor) newInstance;
            Assert.AreEqual(serverDescriptor, newServerDescriptor);
        }
    }
}
