﻿
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA;

namespace OpcLabs.OpcInteroperabilityTest.UA.Servers
{
    [TestClass]
    // ReSharper disable once InconsistentNaming
    public class SoftingIndustrialAutomation_OpcUANetStandardServerSdk_Test : UAInteroperabilityWorkshopTest
    {
        public override IEnumerable<UANodeDescriptor> ArrayReadableNodes => new UANodeDescriptor[]
        {
            "nsu=http://softing.com/Softing.Opc.Ua.Toolkit.Samples/ReferenceApplications ;ns=7;s=CTT_DataAccess_AnalogType_Array_Int32"
        };

        public override IEnumerable<UANodeDescriptor> ArrayWriteableNodes => new UANodeDescriptor[]
        {
            "nsu=http://softing.com/Softing.Opc.Ua.Toolkit.Samples/ReferenceApplications ;ns=7;s=CTT_DataAccess_AnalogType_Array_Int16"
        };

        public override IEnumerable<UANodeDescriptor> DynamicNodes => new UANodeDescriptor[]
        {
            "nsu=http://softing.com/Softing.Opc.Ua.Toolkit.Samples/ReferenceApplications ;ns=7;s=CTT_Scalar_Simulation_Int32",
            "nsu=http://softing.com/Softing.Opc.Ua.Toolkit.Samples/ReferenceApplications ;ns=7;s=CTT_Scalar_Simulation_Double"
        };

        public override IEnumerable<UAEndpointDescriptor> EndpointDescriptors => new UAEndpointDescriptor[] { "opc.tcp://laamw10:61510/UA/DemoServer" };

        public override IEnumerable<string> ServerNotSupportedTests => base.ServerNotSupportedTests.Concat(new[]
        {
            nameof(Group001_Session_Test02_CreateSession_UaTcp_Basic128Rsa15),
        });

        public override string Password => "pwd";

        public override IEnumerable<UANodeDescriptor> StaticNodes => new UANodeDescriptor[]
        {
            "nsu=http://softing.com/Softing.Opc.Ua.Toolkit.Samples/ReferenceApplications ;ns=7;s=CTT_Scalar_Scalar_Static_Int32",
            "nsu=http://softing.com/Softing.Opc.Ua.Toolkit.Samples/ReferenceApplications ;ns=7;s=CTT_Scalar_Scalar_Static_Double"
        };

        public override string UserName => "usr";

        public override IEnumerable<UANodeDescriptor> WriteableNodes => new UANodeDescriptor[]
        {
            "nsu=http://softing.com/Softing.Opc.Ua.Toolkit.Samples/ReferenceApplications ;ns=7;s=CTT_Scalar_Scalar_Static_UInt16",
            "nsu=http://softing.com/Softing.Opc.Ua.Toolkit.Samples/ReferenceApplications ;ns=7;s=CTT_Scalar_Scalar_Static_Int64"
        };
    }
}
