﻿using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA;

namespace OpcLabs.OpcInteroperabilityTest.UA.Servers
{
    [TestClass]
    // ReSharper disable once InconsistentNaming
    public class TakebishiCorporation_DeviceXPlorerOpcServer_Test : UAInteroperabilityWorkshopTest
    {
        public override IEnumerable<UANodeDescriptor> ArrayReadableNodes => new UANodeDescriptor[]
        {
            "nsu=urn:Takebishi:DxpOpcUaServer:customprovider ;ns=2;s=Static.Array.ArrayUInt16"
        };

        public override IEnumerable<UANodeDescriptor> ArrayWriteableNodes => new UANodeDescriptor[]
        {
            "nsu=urn:Takebishi:DxpOpcUaServer:customprovider ;ns=2;s=Static.Array.ArrayUInt64"
        };

        public override IEnumerable<UANodeDescriptor> DynamicNodes => new UANodeDescriptor[]
        {
            "nsu=urn:Takebishi:DxpOpcUaServer:customprovider ;ns=2;s=Rand.Scalar.Int16",
            "nsu=urn:Takebishi:DxpOpcUaServer:customprovider ;ns=2;s=Rand.Scalar.UInt16"
        };

        public override IEnumerable<UAEndpointDescriptor> EndpointDescriptors => new UAEndpointDescriptor[] { "opc.tcp://TAKEBISHI01:52240" };

        public override IEnumerable<string> ServerNotSupportedTests => base.ServerNotSupportedTests.Concat(new[]
        {
            nameof(Group001_Session_Test03_ActivateSession_UserNameAndPassword),
            nameof(Group001_Session_Test09_CreateSession_Https_None),
            nameof(Group001_Session_Test10_ActivateSession_X509Certificate),
            nameof(Group001_Session_Test11_CreateSession_UaTcp_Basic256Sha256),
            nameof(Group008_Eventing_Test04_EventNodes_Browse),
            nameof(Group011_AlarmCondition_Test01_Browse_Types),
            nameof(Group013_Discovery_Test03_FindServers_LDS_ServerPresence)
        });

        public override string Password => "";

        public override IEnumerable<UANodeDescriptor> StaticNodes => new UANodeDescriptor[] { "nsu=urn:Takebishi:DxpOpcUaServer:customprovider ;ns=2;s=Static.Scalar.Double" };

        public override string UserName => null;

        public override IEnumerable<UANodeDescriptor> WriteableNodes => new UANodeDescriptor[] { "nsu=urn:Takebishi:DxpOpcUaServer:customprovider ;ns=2;s=Static.Scalar.Float" };
    }
}
